Bug 1768192 - Review Request: git-secrets - Prevents committing secrets and credentials into git repos
Summary: Review Request: git-secrets - Prevents committing secrets and credentials int...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Elliott Sales de Andrade
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-11-03 10:28 UTC by Kees de Jong
Modified: 2020-02-08 02:00 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-02-08 01:37:59 UTC
Type: ---
quantum.analyst: fedora-review+


Attachments (Terms of Use)

Description Kees de Jong 2019-11-03 10:28:36 UTC
Spec URL: https://github.com/AquaL1te/git-secrets/blob/master/git-secrets.spec
SRPM URL: https://github.com/AquaL1te/git-secrets/blob/master/git-secrets-1.3.0-1.fc30.src.rpm
Description: Prevents you from committing passwords and other sensitive information to a git repository
Fedora Account System Username: keesdejong


I myself have a few questions.
* I encountered this error: "error: Empty %files file /builddir/build/BUILD/git-secrets-1.3.0/debugsourcefiles.list", which I solved by adding this to the top of the spec file: "%global debug_package %{nil}". But the correct way it to set the BuildArch to noarch, correct?
* The default prefix is set to /usr/local, I substituted the prefix line in Makefile with a sed command. Is this correct? Or is that a way to override the prefix with e.g. "%_prefix /usr? somewhere in the spec file?
* I wrote "repos" instead of repositories, rpmlint complains about it. Is the description in the spec file allowed to exceed 79 characters for this?


Scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=38729027



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. Licenses found: "Unknown or generated", "*No
     copyright* Apache License (v2.0)", "Apache License (v2.0)", "Expat
     License". 21 files have unknown license. Detailed output of
     licensecheck in /home/kjong/git/git-secrets/review-git-
     secrets/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[?]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[?]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[-]: Requires correct, justified where necessary.
[?]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[?]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[-]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: git-secrets-1.3.0-1.fc32.x86_64.rpm
          git-secrets-1.3.0-1.fc32.src.rpm
git-secrets.x86_64: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
git-secrets.x86_64: W: no-version-in-last-changelog
git-secrets.x86_64: E: no-binary
git-secrets.src: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
git-secrets.src: W: no-version-in-last-changelog
git-secrets.src: W: strange-permission git-secrets-1.3.0.tar.gz 640
git-secrets.src: W: strange-permission git-secrets.spec 640
2 packages and 0 specfiles checked; 1 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
git-secrets.x86_64: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
git-secrets.x86_64: W: no-version-in-last-changelog
git-secrets.x86_64: W: invalid-url URL: https://github.com/awslabs/git-secrets/ <urlopen error [Errno -2] Name or service not known>
git-secrets.x86_64: E: no-binary
1 packages and 0 specfiles checked; 1 errors, 3 warnings.



Source checksums
----------------
https://github.com/awslabs/git-secrets/archive/1.3.0.tar.gz#/git-secrets-1.3.0.tar.gz :
  CHECKSUM(SHA256) this package     : f1d50c6c5c7564f460ff8d279081879914abe920415c2923934c1f1d1fac3606
  CHECKSUM(SHA256) upstream package : f1d50c6c5c7564f460ff8d279081879914abe920415c2923934c1f1d1fac3606


Requires
--------
git-secrets (rpmlib, GLIBC filtered):
    /usr/bin/bash



Provides
--------
git-secrets:
    git-secrets
    git-secrets(x86-64)



Generated by fedora-review 0.7.3 (44b83c7) last change: 2019-09-18
Command line :/usr/bin/fedora-review -n git-secrets
Buildroot used: fedora-rawhide-{{ target_arch }}
Active plugins: Generic, Shell-api
Disabled plugins: C/C++, Ocaml, Perl, R, Java, Haskell, SugarActivity, fonts, PHP, Python
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 1 Kees de Jong 2019-11-03 10:43:36 UTC
Upstream repo: https://github.com/awslabs/git-secrets

Comment 2 Elliott Sales de Andrade 2019-11-04 09:05:50 UTC
Can you not do `%make_build PREFIX=%{_prefix}` (not %{_usr}!)?

Also, please use raw links so fedora-review works.

Comment 3 Kees de Jong 2019-11-04 09:25:52 UTC
(In reply to Elliott Sales de Andrade from comment #2)
> Can you not do `%make_build PREFIX=%{_prefix}` (not %{_usr}!)?
> 
> Also, please use raw links so fedora-review works.

Please define what you mean with raw links to make fedora-review work, then I'll have a look to fix it. Do you perhaps mean that I should've posted the fedora-review data also in GitHub and provide that as a link?
Your suggestion to override the prefix doesn't work. I'm also not entirely sure if it can be overridden in the conventional way, since there is no ./configure needed for this install. Just `make install`, which then uses the prefixes in the Makefile to install the files in the specified paths.

Comment 4 Elliott Sales de Andrade 2019-11-08 09:00:11 UTC
The links you've used go to a GitHub webpage; they need to point directly to the raw file. Use the Download button on GitHub to get it.

In the Makefile, PREFIX is set using ?=, which means it should only be set if undefined. So setting it on the command-line would override (or rather, skip setting) the value from the file. But you'd need to override PREFIX for both %build and %install to work.

Comment 5 Elliott Sales de Andrade 2019-11-08 09:01:16 UTC
> Use the Download button on GitHub to get it.

Download or Raw button, depending on where you're looking at the file.

Comment 6 Kees de Jong 2019-11-09 09:09:24 UTC
(In reply to Elliott Sales de Andrade from comment #4)
> The links you've used go to a GitHub webpage; they need to point directly to
> the raw file. Use the Download button on GitHub to get it.
> 
> In the Makefile, PREFIX is set using ?=, which means it should only be set
> if undefined. So setting it on the command-line would override (or rather,
> skip setting) the value from the file. But you'd need to override PREFIX for
> both %build and %install to work.

Perfect! Thanks for your help, it indeed works when the prefix is overridden in both stages.

Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=38853301
Spec URL: https://raw.githubusercontent.com/AquaL1te/git-secrets/master/git-secrets.spec
SRPM URL: https://github.com/AquaL1te/git-secrets/raw/master/git-secrets-1.3.0-1.fc30.src.rpm

Comment 7 Elliott Sales de Andrade 2019-11-21 08:45:01 UTC
Source0 can be written https://github.com/awslabs/%{name}/archive/%{version}/%{name}-%{version}.tar.gz

Missing version in %changelog.

Can you not run tests in %check? There seems to be a test directory.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. No licenses found. Please check the source files for
     licenses manually.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[?]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: git-secrets-1.3.0-1.fc32.noarch.rpm
          git-secrets-1.3.0-1.fc32.src.rpm
git-secrets.noarch: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
git-secrets.noarch: W: no-version-in-last-changelog
git-secrets.src: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
git-secrets.src: W: no-version-in-last-changelog
git-secrets.src: W: strange-permission git-secrets-1.3.0.tar.gz 640
git-secrets.src: W: strange-permission git-secrets.spec 640
2 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
git-secrets.noarch: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
git-secrets.noarch: W: no-version-in-last-changelog
1 packages and 0 specfiles checked; 0 errors, 3 warnings.



Source checksums
----------------
https://github.com/awslabs/git-secrets/archive/1.3.0.tar.gz#/git-secrets-1.3.0.tar.gz :
  CHECKSUM(SHA256) this package     : f1d50c6c5c7564f460ff8d279081879914abe920415c2923934c1f1d1fac3606
  CHECKSUM(SHA256) upstream package : f1d50c6c5c7564f460ff8d279081879914abe920415c2923934c1f1d1fac3606


Requires
--------
git-secrets (rpmlib, GLIBC filtered):
    /usr/bin/bash



Provides
--------
git-secrets:
    git-secrets



Generated by fedora-review 0.7.3 (44b83c7) last change: 2019-09-18
Command line :/usr/bin/fedora-review -b 1768192 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-{{ target_arch }}
Active plugins: Shell-api, Generic
Disabled plugins: PHP, fonts, Haskell, Java, SugarActivity, C/C++, Ocaml, Perl, R, Python
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 8 Kees de Jong 2019-11-21 15:37:04 UTC
Thanks! I forgot about that option. I've included the %check and your other suggestions. The changes are included in git. The `make test` runs without errors.

New koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=39170765
New SRC RPM (F31): https://github.com/AquaL1te/git-secrets/blob/master/git-secrets-1.3.0-1.fc31.src.rpm

Comment 9 Elliott Sales de Andrade 2019-11-25 08:30:25 UTC
You shouldn't use internal macros like %__make; just run make directly.

Also, remember to link both spec and srpm.

Comment 10 Elliott Sales de Andrade 2019-11-25 08:32:21 UTC
If you need git at build time, do you not need it at runtime, too? Also, do you need full git, or can git-core work?

Comment 11 Kees de Jong 2020-01-02 14:20:10 UTC
> You shouldn't use internal macros like %__make; just run make directly.
Is there a reason for this? If the macro exists, then it can be used, right? I haven't read anything about this in the maintainer guide. I figured, the macro exists, so that implies it may be used.

> Also, remember to link both spec and srpm.
The links are still the same, but are changed on GitHub. I'll include them now anyway.

> If you need git at build time, do you not need it at runtime, too? Also, do you need full git, or can git-core work?
Good one! git-core is indeed sufficient too and is indeed also needed for runtime.

I've updated the spec file and created new builds:
Spec URL: https://github.com/AquaL1te/git-secrets/blob/master/git-secrets.spec
SRPM URL: https://github.com/AquaL1te/git-secrets/blob/master/git-secrets-1.3.0-1.fc30.src.rpm
Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=40051909

Comment 12 Kees de Jong 2020-01-02 14:21:40 UTC
I copy pasted the URLs from the top of the thread, which did not contain the raw links. Below are the raw links.

Spec URL: https://raw.githubusercontent.com/AquaL1te/git-secrets/master/git-secrets.spec
SRPM URL: https://github.com/AquaL1te/git-secrets/raw/master/git-secrets-1.3.0-1.fc30.src.rpm

Comment 13 Elliott Sales de Andrade 2020-01-03 04:44:45 UTC
fedora-review 404s downloading those links.

Comment 14 Elliott Sales de Andrade 2020-01-03 04:48:12 UTC
(In reply to Kees de Jong from comment #11)
> > You shouldn't use internal macros like %__make; just run make directly.
> Is there a reason for this? If the macro exists, then it can be used, right?
> I haven't read anything about this in the maintainer guide. I figured, the
> macro exists, so that implies it may be used.
> 

No, it's internal, and there's no need to use it. Just because it exists, doesn't mean it should be used.

https://docs.fedoraproject.org/en-US/packaging-guidelines/#_macros

> Macro forms of system executables SHOULD NOT be used except when there is a need to allow the location of those executables to be configurable. For example, rm should be used in preference to %{__rm}, but %{__python3} is acceptable.

Comment 16 Elliott Sales de Andrade 2020-01-04 00:33:10 UTC
LGTM now.

Comment 17 Gwyn Ciesla 2020-01-28 14:15:41 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/git-secrets

Comment 18 Fedora Update System 2020-01-29 09:22:52 UTC
FEDORA-2020-928c1fe149 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-928c1fe149

Comment 19 Fedora Update System 2020-01-31 01:29:41 UTC
git-secrets-1.3.0-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-928c1fe149

Comment 20 Fedora Update System 2020-01-31 02:25:47 UTC
git-secrets-1.3.0-1.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-64bad07edc

Comment 21 Fedora Update System 2020-02-08 01:37:59 UTC
git-secrets-1.3.0-1.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.

Comment 22 Fedora Update System 2020-02-08 02:00:39 UTC
git-secrets-1.3.0-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.